"""Abstract Set:
common set operations"""
class AbstractSet:
  def contains(self,x): raise NotImplementedError,"set.contains()"
  def insert(self,x): raise NotImplementedError,"set.insert()"
  def delete(self,x): raise NotImplementedError,"set.delete()"
  def members(self): raise NotImplementedError,"set.members()"
  def new(self): raise NotImplementedError,"set.new()"
  def copy(self): raise NotImplementedError,"set.copy()"
  def size(self): raise NotImplementedError,"set.size()"

  def __init__(self): pass

  def insertAll(self,elems):
	for x in elems: self.insert(x)
	return self

  def removeAny(self):
	e=self.members()
	if len(e)>0:
		x=e[0]
		self.delete(x)
		return x
	return None

  def union(self,s):
	r=self.copy()
	for x in s.members():
		r.insert(x)
	return r

  def intersection(self,s):
	r=self.new()
	for x in self.members():
		if s.contains(x):
			r.insert(x)
	return r

  def __str__(self):
	r=self.members()
	return "{"+str(r)[1:-1]+"}"
  __repr__ = __str__
