""" DEQueueDecorator - double-ended queue decorator """
class DEQueueDecorator:
	"Base class for decorators of double-ended queues"
	def __init__(self,dequeue):
		self.rep=dequeue
	def put(self,x):
		"Put at end of a DEQueue: q.put(x)"
		self.rep.put(x)
	def push(self,x):
		"Push at front of a DEQueue: q.push(x)"
		self.rep.push(x)
	def get(self):
		"Get item from front of a DEQueue: q.get()"
		return self.rep.get()
	def pop(self):
		"Pop item from front of a DEQueue: =q.get()"
		return self.get()
	def pull(self):
		"Get item from end of a DEQueue: q.pull()"
		return self.rep.pull()
	def copy(self):
		"Copy of a DEQueueue: q.copy()"
		return DEQueueDecorator(self.rep.copy())
	def __getitem__(self,i):
		"Look at i-th item: q[i]"
		return self.rep[i]
	def __len__(self):
		return len(self.rep)
	def __nonzero__(self):
		return len(self.rep)!=0
	def __repr__(self):
		return "DEQueueDecorator("+repr(rep)+")"
	def __str__(self):
		return repr(self)

