"""ListSet
List implementation of an abstract set"""
import AbstractSet
class ListSet(AbstractSet.AbstractSet):
	def __init__(self,elems=()):
		AbstractSet.AbstractSet.__init__(self)
		self.rep=[]
		self.insertAll(elems)

	def contains(self,x): 
		return x in self.rep

	def insert(self,x): 
		if x not in self.rep:
			self.rep.append(x)
		return self

	def delete(self,x):
		if x in self.rep:
			self.rep.remove(x)
		return self

	def members(self):
		return self.rep[:]

	def new(self):
		return ListSet()

	def copy(self):
		c=ListSet()
		c.rep=self.rep[:]
		return c

	def size(self): 
		return len(self.rep)
