""" PureSet: Adapter to treat a set as a pure value """
import Set,types
class PureSet:
	"""PureSet(rep=s)
	A protection proxy for a set, it removes the 
	insert and delete methods and passes all 
	other method calls on to set s. """
	def __init__(self,rep=None):
		if rep is None:
			rep=Set.Set()
		elif not isinstance(rep,Set.Set):
			rep=Set.Set(rep)
		self.with=rep.with
		self.without=rep.without
		self.contains=rep.contains
		self.__contains__=rep.__contains__
		self.members=rep.members
		self.items=rep.items
		self.elements=rep.elements
		self.__or__=rep.__or__
		self.__and__=rep.__and__
		self.__sub__=rep.__sub__
		self.issubsetof=rep.issubsetof
		self.ispropersubsetof=rep.ispropersubsetof
		self.equals=rep.equals
		self.__cmp__=rep.__cmp__
		self.__getitem__=rep.__getitem__
		self.copy=rep.copy
		self.new=rep.new
		self.arb=rep.arb
		self.__len__=rep.__len__
		self.__nonzero__=rep.__nonzero__
		self.__str__=rep.__str__
		self.__repr__=rep.__repr__

emptySet=PureSet(rep=Set.Set())

