import sys
def lengRHS(rhs,size):
	n=0
	for s in rhs:
		if size[s] is None:
			return None
		else:
			n+=size[s]
	return n
def printprod(n,r):
	print >>sys.stderr,n,'=',
	for s in r:
		print >>sys.stderr,s,
	print >>sys.stderr,'.'

def CheckActions(tables,semantics):
	size={}
	size['DOPENDINGACTIONS']=0
	size['BACKUP']=-1
	for n in tables.nonterminals:
		size[n]=None
	for t in tables.terminals:
		size[t]=1
	errors=0
	for a in tables.actions:
	    if a!='DOPENDINGACTIONS' and a!='BACKUP':
		try:
			fn,N=semantics.actionRoutineInfo(a)
			size[a]=1-N
		except:
			print >>sys.stderr,"action symbol",a,"does not have a definition"
			errors+=1
	changes=1
	while changes:
		changes=0
		for n in tables.nonterminals:
			if size[n] is None:
				N=lengRHS(tables.minLengRHS[n],size)
				if N is not None:
					size[n]=N
					changes=1
	for n in tables.nonterminals:
		#print >>sys.stderr,n,size[n]
		pass
	if size[tables.start]!=1:
		print >>sys.stderr,"Semantics stack should end containing one symbol,", \
			"but instead it ends with",size[tables.start]
		
	for n in tables.nonterminals:
		if tables.deflt.has_key(n):
			if size[n]!=lengRHS(tables.deflt[n],size):
				print >>sys.stderr,"inconsistent sizes for",n,":"
				print >>sys.stderr,lengRHS(tables.deflt[n],size),':',
				printprod(n,tables.deflt[n])
				print >>sys.stderr,size[n],':',
				printprod(n,tables.minLengRHS[n])
	for n in tables.nonterminals:
		if tables.sel.has_key(n):
		    for t in tables.sel[n].keys():
			if size[n]!=lengRHS(tables.sel[n][t],size):
				print >>sys.stderr,"inconsistent sizes for",n,":"
				print >>sys.stderr,lengRHS(tables.sel[n][t],size),':',
				printprod(n,tables.sel[n][t])
				print >>sys.stderr,size[n],':',
				printprod(n,tables.minLengRHS[n])
	return size

	
if __name__=='__main__':
	import Calc_Tables,CalcTree
	z=CheckActions(Calc_Tables,CalcTree.CalcSemantics())
	for n in z.keys():
		if n in Calc_Tables.actions:
			print n,'changes by',z[n]
	print '---------'
	import testllk1_Tables,LLkParser
	print 'max backups in Calc_Tables:',LLkParser.countBACKUPs(Calc_Tables)
	print '---------'
	print 'max backups in testllk1_Tables:',LLkParser.countBACKUPs(testllk1_Tables)

