
import string

class StringScanner:
	def __init__(self,s=""):
		self.setSubject(s)
	def setSubject(self,s):
		self.subject=s
		self.cursor=self.markPos=0
		self.successFlag=1
		self.length=len(s)
	def success(self):
		temp=self.successFlag
		self.successFlag=1
		return temp
	def failure(self):
		temp=not self.successFlag
		self.successFlag=1
		return temp
	def setSuccess(self, flag):
		self.successFlag=flag
	def substring(self,start=None,end=None):
		if start==None:
			return substring(self.markPos,self.cursor);
		elif end==None:
			return substring(start,self.cursor);
		elif start<=end:
			return self.subject.substring(start,end);
		else: 
			return self.subject.substring(end,start);
	def mark(self):
		self.markPos=self.cursor
	def reset(self):
		self.cursor=self.markPos
	def atEnd(self):
		if (self.cursor==self.length):
			return 1
		else:
			self.successFlag=0
			return 0
	def at(self, pos):
		if (self.cursor==self.pos):
			return 1
		else:
			self.successFlag=0
			return 0
	def pos(self):
		return self.cursor

	def tab(self,pos):
		if pos>=0:
			if(pos<=self.length):
				self.cursor=pos
				return 1
		else:
			temp=self.length+self.pos;
			if temp<=self.length and temp>=0:
				self.cursor=temp
				return 1
		self.successFlag=0
		return 0
	def tabToEnd(self):
		self.cursor=self.length
		return 1
	def move(self,dist):
		tmp=self.tab(self.cursor+dist)
		if (tmp):
			return 1
		self.successFlag=0
		return 0
	def any(self, s):
		if self.cursor<self.length and \
				self.subject[self.cursor] in s:
			self.cursor+=1
			return 1
		self.successFlag=0
		return 0
	def many(self, s):
		if self.cursor<self.length and \
				self.subject[self.cursor] in s:
			self.cursor+=1
			while cursor<length and \
				self.subject[self.cursor] in s:
				self.cursor+=1
			return 1
		self.successFlag=0
		return 0
	def upto(self, s):
		pos=self.cursor
		while self.cursor<self.length and \
				self.subject[self.cursor] in s:
			self.cursor+=1
		if (self.cursor<self.length):
			return 1
		self.cursor=pos
		self.successFlag=0
		return 0
	def match(self,s):
		if self.cursor<self.length and \
			self.subject.startswith(s,self.cursor):
				self.cursor+=len(s)
				return 1
		self.successFlag=0
		return 0
	def find(self,s) :
		if self.cursor<self.length:
			pos=self.subject.find(s,self.cursor)
			if pos>=0:
				self.cursor=pos
				return 1
		self.successFlag=0
		return 0
	def findMatch(self,s):
		if self.cursor<self.length:
			pos=self.subject.find(s,self.cursor);
			if pos>=0:
				self.cursor=pos+len(s)
				return 1
		self.successFlag=0
		return 0
	def __getitem__(self,i):
		return self.subject[i]
	def charAtCursor(self):
		return self.subject[self.cursor]
	def getMark(self):
		return self.markPos
	def setMark(self,pos):
		if pos<0:
			pos=self.length-pos
		if pos>=0 and pos<self.length: 
			self.markPos=pos
			return 1
		return 0
	def __len__(self):
		return self.length
