#Scanner for Calc, simple calculator
import toolsofcomputing_org.tcllk.Token as Token,re
pat=re.compile(r"""((?x)([a-zA-Z][a-zA-Z0-9]*)|
			([-=+*/%();])|
			([0-9]+)|
			\Z)""")
whitespace=re.compile(r"\s*")
class CalcScanner:
	def __init__(self,src,srcname):
		self.src=src
		self.srcname=srcname
		self.line=None 
		self.lineno=0
		self.col=0
		self.eof=None
	def scan(self):
	    while 1:
		if self.eof: return self.eof.copy()
	    	if self.line is None:
			self.line=self.src.readline()
			self.col=0
			self.lineno+=1
		r=whitespace.match(self.line,self.col)
		self.col=r.end()
		if self.col==len(self.line):
			if self.line=='': 
				self.eof=Token.mkToken( \
				  "EOI","EOI", \
				  self.lineno,self.col, \
				  self.srcname)
				return self.eof.copy()
			self.line=None
			return Token.mkToken("EOL","EOL", \
				  self.lineno,self.col, \
				  self.srcname)
		r=pat.match(self.line,self.col)
		if r==None:
			print "bad character '"+ \
				self.line[self.col]+"' at", \
				self.lineno,self.col
			self.col+=1
			continue
		#print r.groups()
		gs=r.groups()
		try:
			if gs[1]: 
				return Token.mkToken("id",gs[1], \
				  self.lineno,self.col,self.srcname)
			elif gs[2]:
				return Token.mkToken(gs[2],gs[2], \
				  self.lineno,self.col,self.srcname)
			elif gs[3]:
				return Token.mkToken('num',gs[3], \
				  self.lineno,self.col,self.srcname)
		finally: self.col=r.end()
